import { SBaseEditScene, SBaseLineEdit, SBaseTextEdit, SBaseImageEdit, SBaseExpainEdit } from "./../big-edit";
// import { SGraphItem } from "@persagy-web/graph/";
import { SGraphEdit } from "./../edit"
import { SMouseEvent } from "@persagy-web/base/lib";
import { SItemStatus } from "@persagy-web/big/lib/enums/SItemStatus";
import { uuid } from "./../big-edit/until";
export class PTopoScene extends SBaseEditScene {
    constructor() {
        super()
    }


    onMouseDown(event: SMouseEvent): any {
        if (this.editCmd == "EditBaseLine") {
            this.addLine(event)
            this.clearCmdStatus();
        } else if (this.editCmd == "EditBasetext") {
            this.addTextItem(event);
            this.clearCmdStatus();
        } else if (this.editCmd == "EditBaseImage") {
            this.addImageItem(event)
            this.clearCmdStatus();
        } else if (this.editCmd == "EditBasePostil") {
            this.addExplainItem(event)
            this.clearCmdStatus();
        } else if (this.editCmd == "EditBasePolygon") {
            console.log('编辑多边形')
        } else if (this.editCmd == "EditBaseTriangle") {
            console.log('编辑三角形')
        } else if (this.editCmd == "EditBaseCircle") {
            console.log('编辑圆')
        } else if (this.editCmd == "EditBaseArrows") {
            console.log('编辑箭头')
        } else if (this.editCmd == "") {
            super.onMouseDown(event);
        }

    }

    addLine(event: SMouseEvent) {
        const data = {
            /** ID */
            ID: uuid(),
            /** 名称  */
            Name: '基础直线',
            /** 图标（Image），线类型(Line) */
            Type: "BaseLine",
            /** 位置  */
            Pos: { X: 0, Y: 0 },
            /** 由应用自己定义  */
            Properties: {
            },
            Style: {
                Line: [{ X: event.x, Y: event.y }],
            }
        }
        const lineItem = new SBaseLineEdit(null, data);
        lineItem.status = SItemStatus.Create;
        this.addItem(lineItem);
        this.grabItem = lineItem;
        lineItem.connect("finishCreated", this, this.finishCreated);
        if (this.view) {
            this.view.update();
        }
    }
    addTextItem(event: SMouseEvent) {
        const data = {
            /** ID */
            ID: uuid(),
            /** 名称  */
            Name: '基础文本',
            /** 图标 */
            Type: "BaseText",
            /** 位置  */
            Pos: { X: event.x, Y: event.y },
            /** 由应用自己定义  */
            Properties: {
                // IconUrl: require(`../../assets/images/t-text-hover.png`),
                Text: '请在右侧属性栏输入文字！',
                Color: "#646c73",
                Font: 14,
                BackgroundColor: "#f7f9facc"
            },
            Style: {}
        }
        const item = new SBaseExpainEdit(null, data);
        item.moveTo(event.x, event.y);
        item.selectable = true;
        item.moveable = true;
        this.addItem(item);
        // this.Markers.push(item);
        this.grabItem = null;
        // this.focusItem = item;
        this.finishCreated(item);
        // this.scenceUpdate(this);
    }
    addExplainItem(event: SMouseEvent) {
        const data = {
            /** ID */
            ID: uuid(),
            /** 名称  */
            Name: '基础注释文本',
            /** 图标 */
            Type: "BaseExplain",
            /** 位置  */
            Pos: { X: event.x, Y: event.y },
            /** 由应用自己定义  */
            Properties: {
                // IconUrl: require(`../../assets/images/t-text-hover.png`),
                Text: '请在右侧属性栏输入文字！',
                Color: "#646c73",
                Font: 14,
                BackgroundColor: "#f7f9facc"
            },
            Style: {}
        }
        const item = new SBaseTextEdit(null, data);
        item.moveTo(event.x, event.y);
        item.selectable = true;
        item.moveable = true;
        this.addItem(item);
        // this.Markers.push(item);
        this.grabItem = null;
        // this.focusItem = item;
        this.finishCreated(item);
        // this.scenceUpdate(this);
    }
    addImageItem(event: SMouseEvent) {
        const data = {
            /** ID */
            ID: uuid(),
            /** 名称  */
            Name: '基础图片',
            Num: 1,
            /** 图标（Image），线类型(Line) */
            Type: "BaseImage",
            /** 位置  */
            Pos: { X: event.x, Y: event.y },
            /** 由应用自己定义  */
            Properties: {
                // IconUrl: require(`../../assets/images/t-img-hover.png`),
                StrokeColor: "#c0ccda",
                Url: '',
            },
            Style: {}
        }
        const item = new SBaseImageEdit(null, data);
        item.selectable = true;
        item.moveable = true;
        this.addItem(item);
        this.Markers.push(item);
        this.finishCreated(item);
    }

    finishCreated(item: SGraphEdit): void {
        console.log('finishCreated', item)
        this.grabItem = null;
        item.status = SItemStatus.Normal;
    }
    clearCmdStatus() {

    }
}